
#pragma warning(disable:4312)
#pragma warning(disable:4313)
#pragma warning(disable:4996)

#include "stdafx.h"
#include "ATCodeMgr.h"
#include "HookPoint.h"
#include "CharacterMapper.h"


CHookPoint::CHookPoint(void)
: m_hModule(NULL), m_pCodePoint(0)
{
}

CHookPoint::~CHookPoint(void)
{
	//  ɵ  
	DeleteAllTransCmd();
	
	// Unhook Լ غ
	PROC_UnhookCodePoint UnhookCodePoint = CATCodeMgr::GetInstance()->m_sContainerFunc.pfnUnhookCodePoint;
	if(UnhookCodePoint)
	{
		// Unhook
		UnhookCodePoint( (LPVOID)GetHookAddress() );
	}
}

CHookPoint* CHookPoint::CreateInstance(CString strAddr)
{
	CHookPoint* pInst = new CHookPoint();

	try
	{
		int nIdx = strAddr.ReverseFind(_T('!'));
		
		if(nIdx>=0)
		{
			pInst->m_strModuleName = strAddr.Left(nIdx);

			pInst->m_hModule = GetModuleHandle(pInst->m_strModuleName);
			if(NULL == pInst->m_hModule) throw -4;
			
			_stscanf(strAddr.Mid(nIdx+1), _T("%x"), &pInst->m_pCodePoint);
		}
		else
		{
			pInst->m_hModule = NULL;
			_stscanf(strAddr.Mid(nIdx+1), _T("%x"), &pInst->m_pCodePoint);
		}

		if(NULL == pInst->m_pCodePoint) throw -1;

		// ŷ Լ غ
		PROC_HookCodePoint HookCodePoint = CATCodeMgr::GetInstance()->m_sContainerFunc.pfnHookCodePoint;
		if(HookCodePoint == NULL) throw -2;

		// ŷ
		BOOL bHookRes = HookCodePoint((LPVOID)pInst->GetHookAddress(), PointCallback);
		if(bHookRes == FALSE) throw -3;
		
		TRACE("[aral1]  %p Hooked \n", pInst->GetHookAddress());
	}
	catch(int nErrCode)
	{
		nErrCode = nErrCode;
		delete pInst;
		pInst = NULL;
	}

	return pInst;
}

//////////////////////////////////////////////////////////////////////////
//
//  νϽ ŷ ּҸ ȯմϴ.
//
//////////////////////////////////////////////////////////////////////////
UINT_PTR CHookPoint::GetHookAddress()
{
	return ( (UINT_PTR)m_hModule + m_pCodePoint );
}

//////////////////////////////////////////////////////////////////////////
//
//  νϽ ŷ ּҸ ȭ ڿ · ȯմϴ.
//
//////////////////////////////////////////////////////////////////////////
CString CHookPoint::GetHookAddressString()
{
	CString strRetVal;

	if(NULL == m_hModule)
	{
		strRetVal.Format(_T("0x%p"), m_pCodePoint);
	}
	else
	{
		strRetVal.Format(_T("%s!0x%p"), (LPCTSTR)m_strModuleName, m_pCodePoint);
	}
	
	return strRetVal;
}


//////////////////////////////////////////////////////////////////////////
//
// ο   մϴ.
//
//////////////////////////////////////////////////////////////////////////
CTransCommand* CHookPoint::AddTransCmd(CString strArgScript)
{
	strArgScript.Remove(_T(' '));
	CTransCommand* pCmd = FindTransCmd(strArgScript);
	
	if(pCmd == NULL)
	{
		pCmd = new CTransCommand();
		pCmd->SetArgScript(strArgScript);
		m_vectorTransCmd.push_back(pCmd);
	}

	return pCmd;
}

//////////////////////////////////////////////////////////////////////////
//
//   ãϴ.
//
//////////////////////////////////////////////////////////////////////////
CTransCommand* CHookPoint::FindTransCmd(CString strArgScript)
{
	CTransCommand* pCmd = NULL;

	strArgScript.Remove(_T(' '));
	for(vector<CTransCommand*>::iterator iter = m_vectorTransCmd.begin();
		iter != m_vectorTransCmd.end();
		iter++)
	{
		if((*iter)->GetArgScript().CompareNoCase(strArgScript) == 0)
		{
			pCmd = (*iter);
			break;
		}
	}

	return pCmd;
}


//////////////////////////////////////////////////////////////////////////
//
//     մϴ.
//
//////////////////////////////////////////////////////////////////////////
int CHookPoint::GetTransCmdCount()
{
	return (int)m_vectorTransCmd.size();
}


//////////////////////////////////////////////////////////////////////////
//
// Ư°   մϴ.
//
//////////////////////////////////////////////////////////////////////////
CTransCommand* CHookPoint::GetTransCmd(int nIdx)
{
	CTransCommand* pCmd = NULL;
	
	if((size_t)nIdx < m_vectorTransCmd.size())
	{
		pCmd = m_vectorTransCmd[nIdx];
	}

	return pCmd;
}


//////////////////////////////////////////////////////////////////////////
//
//   մϴ.
//
//////////////////////////////////////////////////////////////////////////
void CHookPoint::DeleteTransCmd(int nIdx)
{
	if((size_t)nIdx < m_vectorTransCmd.size())
	{
		CTransCommand* pCmd = m_vectorTransCmd[nIdx];
		delete pCmd;
		m_vectorTransCmd.erase(m_vectorTransCmd.begin()+nIdx);
	}	
}

//////////////////////////////////////////////////////////////////////////
//
//    մϴ.
//
//////////////////////////////////////////////////////////////////////////
void CHookPoint::DeleteAllTransCmd()
{
	for(vector<CTransCommand*>::iterator iter = m_vectorTransCmd.begin();
		iter != m_vectorTransCmd.end();
		iter++)
	{
		CTransCommand* pCmd = (*iter);
		delete pCmd;
	}

	m_vectorTransCmd.clear();
}



//////////////////////////////////////////////////////////////////////////
//
// Ư ŷ ݹ Լ (static)
//
//////////////////////////////////////////////////////////////////////////
void CHookPoint::PointCallback(LPVOID pHookedPoint, PREGISTER_ENTRY pRegisters)
{
	
	CATCodeMgr* pATCodeMgr = CATCodeMgr::GetInstance();
	if(NULL == pATCodeMgr) return;

	// Ÿʿ ŷ ϱ
	for(list<CHookPoint*>::iterator iter = pATCodeMgr->m_listHookPoint.begin();
		iter != pATCodeMgr->m_listHookPoint.end();
		iter++)
	{
		CHookPoint* pPoint = (*iter);
		if(pPoint->GetHookAddress() == (UINT_PTR)pHookedPoint)
		{
			//   
			pPoint->ExecuteTransCmds(pRegisters);
			break;
		}
	}

}

//////////////////////////////////////////////////////////////////////////
//
//  ۾  (ƼƮ / ڵ )
//
//////////////////////////////////////////////////////////////////////////
void CHookPoint::ExecuteTransCmds(PREGISTER_ENTRY pRegisters)
{
	int cnt = GetTransCmdCount();

	m_parser.SetRegisterValues(pRegisters);

	for(int i=0; i<cnt; i++)
	{
		CTransCommand* pCmd = GetTransCmd(i);		
		LPVOID pArgText = NULL;

		int nType;
		int* pRetVal = (int*)m_parser.GetValue(pCmd->GetArgScript(), &nType);
		if(pRetVal && 1 == nType)
		{
			pArgText = *(LPVOID*)pRetVal;
			delete pRetVal;
		}

		if(pArgText == NULL || IsBadReadPtr(pArgText, sizeof(LPVOID)) || (*(BYTE*)pArgText) == 0) continue;
		
		try
		{
			BOOL bTrans = FALSE;
			CString strClipboardText = _T("");

			// ڵ ̶
			if(pCmd->GetUnicode())
			{
				LPWSTR wszText = (LPWSTR)pArgText;
				if( IsBadStringPtrW(wszText, 1024*1024*1024) ) throw -3; // _T("߸ ڿ Դϴ.");

				// ֱ  ѱΰ
				wchar_t wszPureText[MAX_TEXT_LENGTH];
				wcscpy(wszPureText, wszText);
				size_t wlen = wcslen(wszPureText);
				while(wlen>0 && wszPureText[wlen-1] == L' ')
				{
					wszPureText[wlen-1] = L'\0';
					wlen--;
				}
				if( wcslen((LPCWSTR)pCmd->m_pTransTextBuf) > 0 && wcsstr((LPCWSTR)pCmd->m_pTransTextBuf, wszPureText) )
				{
					throw -1; //_T(" ġ ߺ Ϸ մϴ.");
				}

				// ֱ ó Ϻ ƴ ο ̶
				if( wcscmp(wszText, (LPCWSTR)pCmd->m_pOrigTextBuf) )
				{
					
					// ֱ Ϻ 
					ZeroMemory(pCmd->m_pOrigTextBuf, sizeof(pCmd->m_pOrigTextBuf));
					wcscpy((LPWSTR)pCmd->m_pOrigTextBuf, wszText);

					// ƼƮ ȯ
					char szAnsiJpn[MAX_TEXT_LENGTH*2];
					char szAnsiKor[MAX_TEXT_LENGTH*2];

					MyWideCharToMultiByte(932, 0, wszText, -1, szAnsiJpn, MAX_TEXT_LENGTH*2, NULL, NULL);

					// Ϻ  Ŭ  ˻
					if( pCmd->GetClipJpn() )
					{
#ifdef UNICODE
						strClipboardText += wszText;
#else
						strClipboardText += szAnsiJpn;
#endif
					}

					// ⿡ ־
					PROC_TranslateText pfnTransJ2K = CATCodeMgr::GetInstance()->m_sContainerFunc.pfnTranslateText;
					if( pfnTransJ2K == NULL ) throw -2; //_T("AT ̳ Լ ã  ϴ.");

					bTrans = pfnTransJ2K(szAnsiJpn, szAnsiKor, MAX_TEXT_LENGTH*2);			
					if( bTrans )
					{
#ifdef UNICODE
						wchar_t wszTmpKor[MAX_TEXT_LENGTH];
						MyMultiByteToWideChar(949, 0, szAnsiKor, -1, wszTmpKor, MAX_TEXT_LENGTH);
						CString strKorean = wszTmpKor;
#else
						CString strKorean = szAnsiKor;
#endif

						// ѱ  Ŭ  ˻
						if( pCmd->GetClipKor() )
						{
							strClipboardText += strKorean;
						}

						//  
						//if(CATCodeMgr::GetInstance()->m_bPtrCheat == FALSE && CATCodeMgr::GetInstance()->m_bRemoveSpace)
						if( pCmd->GetRemoveSpace() )
						{
							strKorean.Replace(_T(" "), _T(""));
						}

						// ֱ ѱ 
						ZeroMemory(pCmd->m_pTransTextBuf, sizeof(pCmd->m_pTransTextBuf));
#ifdef UNICODE
						wcscpy((LPWSTR)pCmd->m_pTransTextBuf, (LPCWSTR)strKorean);
#else
						MyMultiByteToWideChar(949, 0, (LPCSTR)strKorean, -1, (LPWSTR)pCmd->m_pTransTextBuf, MAX_TEXT_LENGTH);
#endif
					}

				}			

			}
			// ƼƮ ̶
			else
			{

				LPSTR szText = (LPSTR)pArgText;
				if( IsBadStringPtrA(szText, 1024*1024*1024) )
				{
					throw -3; //_T("߸ ڿ Դϴ.");
				}

				// ֱ  ѱΰ
				size_t nCmpCnt = strlen(szText);
				while(nCmpCnt > 0 && szText[nCmpCnt-1] == ' ') nCmpCnt--;
				if( strlen((LPCSTR)pCmd->m_pTransTextBuf) > 0 && strncmp(szText, (LPCSTR)pCmd->m_pTransTextBuf, nCmpCnt) == 0 )
				{
					throw -1; //_T(" ġ ߺ Ϸ մϴ.");
				}
				
				// ֱ ó Ϻ ƴ ο ̶
				if( strcmp(szText, (LPCSTR)pCmd->m_pOrigTextBuf) )
				{

					// ߸ ؽƮΰ?
					if(pCmd->GetSafe() && CCharacterMapper::IsShiftJISText(szText) == FALSE)
					{
						TRACE(_T("[aral1] Bad Text \n"));
						throw -4; //_T("Ϻ ؽƮ ƴմϴ.");
					}

					// ֱ Ϻ 
					ZeroMemory(pCmd->m_pOrigTextBuf, sizeof(pCmd->m_pOrigTextBuf));
					strcpy((LPSTR)pCmd->m_pOrigTextBuf, szText);

					// Ϻ  Ŭ  ˻
					if( pCmd->GetClipJpn() )
					{
#ifdef UNICODE
						wchar_t wszTmpJpn[MAX_TEXT_LENGTH];
						MyMultiByteToWideChar(932, 0, szText, -1, wszTmpJpn, MAX_TEXT_LENGTH);
						strClipboardText += wszTmpJpn;
#else
						strClipboardText += szText;
#endif
					}

					// ⿡ ־
					PROC_TranslateText pfnTransJ2K = CATCodeMgr::GetInstance()->m_sContainerFunc.pfnTranslateText;
					if( pfnTransJ2K == NULL )
					{
						throw -2; //"AT ̳ Լ ã  ϴ.";
					}

					bTrans = pfnTransJ2K(szText, (char*)pCmd->m_pTransTextBuf, MAX_TEXT_LENGTH*2);			
					if( bTrans )
					{
#ifdef UNICODE
						wchar_t wszTmpKor[MAX_TEXT_LENGTH];
						MyMultiByteToWideChar(949, 0, (LPCSTR)pCmd->m_pTransTextBuf, -1, wszTmpKor, MAX_TEXT_LENGTH);
						CString strKorean = wszTmpKor;
#else
						CString strKorean = (LPCSTR)pCmd->m_pTransTextBuf;
#endif

						// ѱ  Ŭ  ˻
						if( pCmd->GetClipKor() )
						{
							strClipboardText += strKorean;
						}

						//  
						if( pCmd->GetRemoveSpace() )
						{
							strKorean.Replace(_T(" "), _T(""));
							MyWideCharToMultiByte(949, 0, strKorean, -1, (LPSTR)pCmd->m_pTransTextBuf, MAX_TEXT_LENGTH*2, NULL, NULL);
							//ReduceSpaceA((LPSTR)pCmd->m_pTransTextBuf, (int)strlen(szText));
						}

						// 2Ʈ 籸
						if( pCmd->GetTwoByte() )
						{
							EnforceTwoBtye((LPSTR)pCmd->m_pTransTextBuf);
						}

						// ѱ ڵ (ƼƮ 츸)
						if( CATCodeMgr::GetInstance()->m_bEncodeKorean )
						{
							EncodeMultiBytes((LPSTR)pCmd->m_pTransTextBuf);
						}

					}
				}
			}

			//  ٲġ 
			if( pCmd->GetTransMethod() == 1 )
			{
				CString strScript = pCmd->GetArgScript();
				int nLen = strScript.GetLength();
				
				if(strScript.CompareNoCase(_T("EAX")) == 0) pRegisters->_EAX = (DWORD)(UINT_PTR)pCmd->m_pTransTextBuf;
				else if(strScript.CompareNoCase(_T("EBX")) == 0) pRegisters->_EBX = (DWORD)(UINT_PTR)pCmd->m_pTransTextBuf;
				else if(strScript.CompareNoCase(_T("ECX")) == 0) pRegisters->_ECX = (DWORD)(UINT_PTR)pCmd->m_pTransTextBuf;
				else if(strScript.CompareNoCase(_T("EDX")) == 0) pRegisters->_EDX = (DWORD)(UINT_PTR)pCmd->m_pTransTextBuf;
				else if(strScript.CompareNoCase(_T("ESI")) == 0) pRegisters->_ESI = (DWORD)(UINT_PTR)pCmd->m_pTransTextBuf;
				else if(strScript.CompareNoCase(_T("EDI")) == 0) pRegisters->_EDI = (DWORD)(UINT_PTR)pCmd->m_pTransTextBuf;
				else if(strScript.CompareNoCase(_T("EBP")) == 0) pRegisters->_EBP = (DWORD)(UINT_PTR)pCmd->m_pTransTextBuf;
				else if(strScript.CompareNoCase(_T("ESP")) == 0) pRegisters->_ESP = (DWORD)(UINT_PTR)pCmd->m_pTransTextBuf;
				else if(nLen >= 5 && _T('[') == strScript[0] && _T(']') == strScript[nLen-1])
				{
					int nType;
					int* pRetVal = (int*)m_parser.GetValue(strScript.Mid(1, nLen-2), &nType);
					if(pRetVal && 1 == nType)
					{
						LPBYTE* ppArgText = *(LPBYTE**)pRetVal;
						delete pRetVal;

						if(::IsBadWritePtr(ppArgText, sizeof(LPBYTE)) == FALSE)
						{
							*ppArgText = pCmd->m_pTransTextBuf;
						}

					}
				}
				
			}
			// ޸ Overwrite  (Default)
			else if( pCmd->GetTransMethod() == 2 )
			{
				list<LPVOID> listTexts;
				listTexts.push_back(pArgText);

				// ؾ ġ 
				if(pCmd->GetAllSameText())
				{
					if(pCmd->GetUnicode())
					{
						SearchTextW((UINT_PTR)pRegisters->_EBP, (LPCWSTR)pArgText, &listTexts);
					}
					else
					{
						SearchTextA((UINT_PTR)pRegisters->_EBP, (LPCSTR)pArgText, &listTexts);
					}
				}


				// ġ鿡  ؽƮ Overwrite
				for(list<LPVOID>::iterator iter = listTexts.begin();
					iter != listTexts.end();
					iter++)
				{
					LPVOID pDest = (*iter);
					OverwriteTextBytes(pDest, pCmd->m_pTransTextBuf, pCmd->GetUnicode() );
				}
			}

			// Ŭ 
			if(!strClipboardText.IsEmpty())
			{
				CATCodeMgr::GetInstance()->SetClipboardText(strClipboardText);
			}

		}
		catch (int nErrCode)
		{
			nErrCode = nErrCode;
			TRACE(_T("ExecuteTransCmds exception code : %d \n"), nErrCode);
		}

	} // end of for

}


BOOL CHookPoint::OverwriteTextBytes( LPVOID pDest, LPVOID pSrc, BOOL bWideChar )
{
	if(bWideChar)
	{
		LPWSTR wszDest = (LPWSTR)pDest;
		UINT_PTR nDestLen =  wcslen(wszDest);
		LPWSTR wszSrc = (LPWSTR)pSrc;
		UINT_PTR nSrcLen =  wcslen(wszSrc);

		// ڿ Ͱ ߸Ǿٸ 
		if( IsBadWritePtr(wszDest, nDestLen) || IsBadStringPtrW(wszDest, 1024*1024*1024) ) return FALSE;

		// ؽƮ 
		size_t len = min(nDestLen, nSrcLen);
		memcpy(wszDest, wszSrc, len*sizeof(wchar_t));
		while(len<nDestLen)
		{
			wszDest[len] = L' ';
			len++;
		}

	}
	else
	{

		LPSTR szDest = (LPSTR)pDest;
		UINT_PTR nDestLen =  strlen(szDest);
		LPSTR szSrc = (LPSTR)pSrc;
		UINT_PTR nSrcLen =  strlen(szSrc);

		// ڿ Ͱ ߸Ǿٸ 
		if( IsBadWritePtr(szDest, nDestLen) || IsBadStringPtrA(szDest, 1024*1024*1024) ) return FALSE;

		// ؽƮ 
		size_t len = 0;
		while(len<nDestLen && len<nSrcLen)
		{
			size_t addval = 1;
			if( (BYTE)0x80 <= (BYTE)szSrc[len] ) addval = 2;

			if( len + addval > nDestLen ) break;

			len += addval;
		}

		memcpy(szDest, szSrc, len);
		while(len<nDestLen)
		{
			szDest[len] = ' ';
			len++;
		}

	}

	return TRUE;
}

BOOL CHookPoint::SearchTextA(UINT_PTR ptrBegin, LPCSTR cszText, list<LPVOID>* pTextList)
{
	BOOL bRetVal = FALSE;

	size_t dist = 0;
	size_t nOrigLen = strlen(cszText);

	while( IsBadReadPtr((void*)(ptrBegin+dist), sizeof(void*)) == FALSE )
	{
		LPSTR* ppText = (LPSTR*)(ptrBegin+dist);

		// ġѴٸ
		if( IsBadStringPtrA(*ppText, 1024*1024*1024)==FALSE 
			&& strlen(*ppText) == nOrigLen
			&& strcmp(*ppText, cszText) == 0 )
		{
			// Ͽ ߰
			pTextList->push_back(*ppText);
			bRetVal = TRUE;
		}

		dist += sizeof(void*);
	}

	TRACE(_T(" [ aral1 ] SearchTextA ãŸ:0x%p~0x%p (%d bytes) \n"), ptrBegin, ptrBegin+dist, dist);

	return bRetVal;
}

BOOL CHookPoint::SearchTextW(UINT_PTR ptrBegin, LPCWSTR cwszText, list<LPVOID>* pTextList)
{
	BOOL bRetVal = FALSE;

	size_t dist = 0;
	size_t nOrigLen = wcslen(cwszText);

	while( IsBadReadPtr((void*)(ptrBegin+dist), sizeof(void*)) == FALSE )
	{
		LPWSTR* ppText = (LPWSTR*)(ptrBegin+dist);

		// ġѴٸ
		if( IsBadStringPtrW(*ppText, 1024*1024)==FALSE 
			&& wcslen(*ppText) == nOrigLen
			&& wcscmp(*ppText, cwszText) == 0 )
		{
			// Ͽ ߰
			pTextList->push_back(*ppText);
			bRetVal = TRUE;
		}

		dist += sizeof(void*);

	}	

	TRACE(_T(" [ aral1 ] SearchTextW ãŸ:0x%p~0x%p (%d bytes) \n"), ptrBegin, ptrBegin+dist, dist);

	return bRetVal;
}

BOOL CHookPoint::EnforceTwoBtye(LPSTR szText)
{
	if(NULL == szText) return FALSE;

	char szKorean[MAX_TEXT_LENGTH*2];
	strcpy(szKorean, szText);

	int len = (int)strlen(szKorean);
	int i = 0;
	int j = 0;
	while( i<len )
	{
		if( 0x80 <= (BYTE)szKorean[i] )
		{
			szText[j] = szKorean[i];
			szText[j+1] = szKorean[i+1];

			i+=2;
		}
		else
		{
			
			//WORD wChar = CCharacterMapper::Ascii2ShiftJIS(szKorean[i]);
			WORD wChar = CCharacterMapper::Ascii2KS5601(szKorean[i]);
			if(' ' == szKorean[i]) wChar = 0x8140;
			
			if(wChar)
			{
				szText[j] = (char)HIBYTE(wChar);
				szText[j+1] = (char)LOBYTE(wChar);
			}
			else
			{
				szText[j] = szKorean[i];
				if( 0x80 <= (BYTE)szKorean[i+1] )
				{
					szText[j+1] = ' ';
				}
				else
				{
					++i;
					szText[j+1] = szKorean[i];
				}
			}

			i++;
		}

		j+=2;
	}

	szText[j] = '\0';

	return TRUE;
}

BOOL CHookPoint::EncodeMultiBytes( LPSTR szNewText )
{

	// ƼƮ ڵ
	int len = (int)strlen(szNewText);
	int i = 0;
	while( i<len )
	{
		if( 0x80 <= (BYTE)szNewText[i] )
		{
			char tmpbuf[3];
			tmpbuf[0] = szNewText[i];
			tmpbuf[1] = szNewText[i+1];
			tmpbuf[2] = '\0';

			CCharacterMapper::EncodeK2J(tmpbuf, &szNewText[i]);

			i++;
		}

		i++;
	}
	
	szNewText[i] = '\0';

	return TRUE;
}

BOOL CHookPoint::ReduceSpaceA( LPSTR szText, int nSizeTo )
{
	if(NULL == szText) return FALSE;

	char szKorean[MAX_TEXT_LENGTH*2];
	strcpy(szKorean, szText);

	int len = (int)strlen(szKorean);
	int nRemoveCnt = len - nSizeTo;
	int i = 0;
	int j = 0;
	while( i<len )
	{
		if( 0x80 <= (BYTE)szKorean[i])
		{
			szText[j++] = szKorean[i++];
			szText[j++] = szKorean[i++];
		}
		else
		{
			if(' ' != szKorean[i]  || nRemoveCnt <= 0)
			{
				szText[j++] = szKorean[i];
			}
			else
			{
				nRemoveCnt--;
			}

			i++;
		}
	}

	szText[j] = '\0';

	return TRUE;

}